#include "socket.h"
#include "linserver.h"
#include <ctype.h>
#include "token.h"

void popService(bool socks,int handle,char *sockshost,int socksport) {
	QSocket client,server;
	client.attach(handle);
	client.setException(true);
	server.setException(true);
	char command[1024],name[256],host[256],*p;
	QToken token;

	try {
		client.write("+OK ");
		client.write(VERSION);
		client.write(" POP3 ");
		if (socks) client.write("(SOCKS5)");
		client.write(" Relay Server Ready\r\n");

		while(1) {
			client.read(command,1024);
			QToken::strlwr(command,4);
			if (strncmp(command,"user",4) || !strchr(command,'@'))
				client.write("-ERR 'USER user@hostname' expected\r\n");
			else {
				token.normalize(command);
				p=command+5;
				while(isspace(*p) && *p) p++;
				token.set(p,"@");
				token.get(name); token.get(host);
				if (strlen(name)>0 && strlen(host)>0) break;
				client.write("-ERR ivnalid user or host name\r\n");
			}
		}
		int res;
		if (socks) res=server.connectSOCKS(host,110,sockshost,socksport);
		else res=server.connect(host,110);
		if (!res) return;
		server.readline(command,1024);
		sprintf(command,"USER %s\r\n",name);
		server.write(command);
		QSocket::connectService(client,server);
	}
	catch(...) {
		return;
	}
}

