#include "socket.h"

void socksServer(int handle) {
	QSocket client,server;
	client.attach(handle);

	printf("Working\n");
	unsigned char ch,ch2,buffer[256],address[256],atype,command,temp[20];
	short int port;
	int res;

	try {
		client.read(&ch,1); // GET: Version (must be 5)
		if (ch!=5) return;
		client.read(&ch,1); // GET: NMETHODS
		client.read(buffer,(int)ch); // GET: METHODS
		
		ch2=255;
		for(int i=0;i<(int)ch;i++)
			if (buffer[i]==0) ch2=0;

		ch=5;
		client.write(&ch,1); // PUT: Version
		client.write(&ch2,1); // PUT: Selected Method
		if (ch2!=0) return;

		client.read(&ch,1); // GET: Version
		if (ch!=5) return;
		client.read(&command,1); // GET: Command
		client.read(&ch,1);	// GET: Reserved
		client.read(&atype,1);	// GET: Address Type

		if (atype==1) { 	// IPv4
			client.read(buffer,4);
			sprintf((char*)address,"%d.%d.%d.%d",buffer[0],buffer[1],buffer[2],buffer[3]);
		}
		else if (atype==3) {
			client.read(&ch,1);
			client.read(address,(int)ch);
			address[ch]=0;
		}
		else if (atype==4) {
			client.read(&buffer,16);
			address[0]=0;
			for(int i=0;i<16;i++) {
				sprintf((char*)temp,"%d",buffer[i]);
				strcat((char*)address,(char*)temp);
				if (i!=15) strcat((char*)address,".");
			}
		}
		else return; 

		client.read(&port,2);
		port=htons(port);
		printf("Connection: %s:%d\n",address,port);

		if (command==1)
			res=server.connect((char*)address,port);	

		ch=5; client.write(&ch,1);
		ch=res ? 0 : 5; client.write(&ch,1);
		ch=0; client.write(&ch,1);
		ch=3; client.write(&ch,1);
		ch=strlen((char*)address); client.write(&ch,1);
		client.write(address);
		client.write(&port,2);
		QSocket::connectService(server,client);
	}
	catch(...) {
		return;
	}
}

