#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "token.h"

QToken::QToken() {
	multi=false; first=false;
	tokenString=(char*)NULL;
}

void QToken::set(char *ts,char *del) {
	tokenString=ts; delim=del;
	first=true;
}

bool QToken::get(char *buffer) {
	if (!tokenString || !*tokenString) return false;

	if (!first) {
		tokenString++;
		if (multi) while(strchr(delim,*tokenString)) tokenString++;
	}
	first=false;
	while(*tokenString && !strchr(delim,*tokenString))
		*buffer++=*tokenString++;
	*buffer=0;
	return true;
}

int QToken::total() {
	if (!tokenString) return 0;

	int c=0;
	char *p=tokenString,temp[200];
	bool b=first;
	
	while(get(temp)) c++;
	tokenString=p;
	first=b;
	return c;
}


void QToken::normalize(char *buffer) {
	for(int i=0;i<strlen(buffer);i++)
		if (buffer[i]=='\n' || buffer[i]=='\r') buffer[i]=0;
}

void QToken::strlwr(char *buffer,int len) {
	if (len==-1) len=strlen(buffer);
	for(int i=0;i<len;i++)
		buffer[i]=tolower(buffer[i]);
}

