#include "message.h"
#include <stdio.h>
#include <stdarg.h>


QMessage messageFile;

QMessage::QMessage() {
	file=fopen(MESSAGE_FILE,"a");
	if (!file) file=fopen(MESSAGE_FILE,"w");
	if (!file) {
		fprintf(stderr,"Unable to open message file\n");
		exit(1);
	}
}

QMessage::~QMessage() {
	fclose(file);
}

void QMessage::send(char *buffer,...) {
	va_list ap;
	va_start(ap,buffer);
	vfprintf(file,buffer,ap);
	va_end(ap);
	fprintf(file,"\n");
	fflush(file);
}


