#include "socket.h"
#include "linserver.h"
#include <stdlib.h>

void telnetService(int handle) {
	QSocket client,server;
	client.attach(handle);
	client.setException(true);
	server.setException(true);

	char host[256],port[20];

	try {
		client.write("Welcome to "); client.write(VERSION);
		client.write(" - Telnet Service Ready.\r\nHost> ");
		client.readline(host,256);
		client.write("Port> "); client.readline(port,20);
		client.write("\r\nTrying...");

		if (!server.connect(host,atoi(port))) {
			client.write("Failed\r\n");
			return;
		}
		client.write("Connected\r\n");
		QSocket::connectService(client,server);
	}
	catch(...) {
		return;
	}
}

